{------------------------------------------------------------------------------
                         D I V E R S . P A S

Cette unit contient des routines gnrales utilises par toutes les units de
ce projet. De plus les constantes sont dfinies ici afin de centraliser les appels
-------------------------------------------------------------------------------}
unit Divers;

interface
uses Forms, Ulaser, UMiroir, UObstacle, UCible, messages;

const
// constantes de curseur
       crLaser        = 1;
       crTrnMir       = 2;
       crCible        = 3;
       crObs1         = 4;
       crObs2         = 5;
       crGomme        = 6;
       crMiroir       = 7;
// constantes de mode
       mdNormal    = 0;
       mdMiroir    = 1;
       mdEmetteur  = 2;
       mdCible     = 3;
       mdObstacle1 = 4;
       mdObstacle2 = 5;
       mdGomme     = 6;
// constantes pour savoir ce qu'on touche avec le laser
       ttAucun         = 0;
       ttLaser         = 1;
       ttObstacle      = 2;
       ttMiroirInverse = 3;
       ttCible         = 4;




type
// classe gnrale utilise pour permettre de respecter au mieux le concept objet
// Ainsi, les obstacels, miroirs.. utilisent leur parenr pour savoir comment
// ragir  l'environnement 
  TFeuilleJeu = class(TForm)
    private
      procedure CapteDepl(var msg : TMessage); message WM_NCLBUTTONDOWN;
// capte ce message pour empcher le dplacement de la fentre 
    public
      modifie,                                    // vrai = oblige  redessiner le laser
      Grille      : boolean;                      // vrai alors aligne sur la grille
      Laser       : TLaser;                       // stocke un pointeur pour le laser
      Miroir      : array [0..9] of TMiroir;      // stocke les  miroirs
      Obstacle    : array [0..99] of TObstacle;   // stocke les obstacles
      Cible       : TCible;                       // stocke la cible
      ObsTouche   : shortint;                     // indice du dernier obstacle touch
      TypeTouche,                                 // type de l'objet touch
      NivAct,                                     // niveau actuel
      NbNiv,                                      // nombre total de niveaux
      NbMir,                                      // Nombre total de miroirs
      NbObs,                                      // Nombre total d'obstacles
      mode,                                       // mode de la feuille (Gomme, miroir...)
      Temps        : byte;                        // temps pour faire le niveau
      passe        : string;                      // mot de passe du niveau actuel
      Titre        : string;                      // Titre du niveau actuel
      procedure EffaceLaser;                      // Efface le laser de la feuille

  end;


  procedure ChargeNiveau(Feuille : TFeuilleJeu; Niveau : integer);
// charge le niveau indiqu dans la feuille indique
  function TraceLaser(Feuille : TFeuilleJeu; Xorg, Yorg : integer; Angle : integer; dessine : boolean): shortint;
// trace le laser dans la feuille, aux coordonnes et avec l'angel spcifi. Si dessine
// vaut true, il apparait, sinon il disparait
  function RepAct : string;
// renvoit le rpertoire de lancement de l'application

implementation

uses Principal, Editeur, sysutils, graphics, dialogs, windows, controls, Palette, Niveau;


procedure ChargeNiveau(Feuille : TFeuilleJeu; Niveau : integer);
var fic  : file of byte;
    adr  : word;
    lect : byte;
    i    : integer;
begin
  with Feuille do begin

    AssignFile(fic, RepAct+'\niveaux.dat');
    reset(fic);
    read(fic, nbniv);
    if niveau <= nbniv then begin
      if laser <> nil then begin
        EffaceLaser;
        Laser.visible := false;
      end;
      if cible <> nil then
        Cible.visible := false;
      for i:= 0 to nbmir-1 do
        Miroir[i].visible := false;
      for i := 0 to nbobs -1 do
        Obstacle[i].visible := false;

      nivact := niveau;
      seek(fic, niveau*2-1);
      read(fic, lect);
      adr := lect * 256;
      read(fic, lect);
      adr := adr + lect;
      seek(fic, adr);
      passe := '';
      for i:= 0 to 7 do begin
        read(fic,lect);
        if lect <> 0 then
          passe := passe + chr(lect);
      end;


      Titre := '';
      for i:= 0 to 19 do begin
        read(fic, lect);
        if lect <> 0 then
          titre := titre + chr(lect);
      end;

      read(fic, lect);
      Feuille.temps := lect;

      if Feuille = frmlaseroid then begin
        frmNiveau.lblTitre.caption := Titre;
        frmNiveau.lblPasse.caption := Passe;
        frmNiveau.showmodal;
      end;


      read(fic, nbmir);

      for i:= 0 to nbmir-1 do begin
        if Miroir[i] = nil then begin
          Miroir[i] := TMiroir.create(Feuille);
          Miroir[i].parent := Feuille;
        end
        else
          Miroir[i].visible := true;
        read(fic, lect);
        Miroir[i].left := lect * 256;
        read(fic, lect);
        Miroir[i].left := Miroir[i].left + lect;
        read(fic, lect);
        Miroir[i].top := lect * 256;
        read(fic, lect);
        Miroir[i].top := Miroir[i].top + lect;
        read(fic, lect);
        Miroir[i].angle := 5*lect;
        if Feuille = frmLaseroid then
          Miroir[i].cursor := crTrnMir;
      end;
      read(fic, nbobs);
      for i:= 0 to nbobs -1 do begin
        if Obstacle[i] = nil then begin
          Obstacle[i] := TObstacle.create(Feuille);
          Obstacle[i].parent := Feuille;
        end
        else
          Obstacle[i].visible := true;
        read(fic, lect);
        Obstacle[i].left := lect * 256;
        read(fic, lect);
        Obstacle[i].left := Obstacle[i].left + lect;
        read(fic, lect);
        Obstacle[i].top := lect * 256;
        read(fic, lect);
        Obstacle[i].top := Obstacle[i].top + lect;
        read(fic, lect);
        Obstacle[i].sorte := lect;
        Obstacle[i].Etat := 20;
      end;
      if Laser = nil then begin
        Laser := Tlaser.create(Feuille);
        Laser.parent := Feuille;
      end
      else
        Laser.visible := true;
      read(fic, lect);
      Laser.left := lect * 256;
      read(fic, lect);
      Laser.left := Laser.left + lect;
      read(fic, lect);
      Laser.top := lect * 256;
      read(fic, lect);
      Laser.top := Laser.top + lect;
      read(fic, lect);
      Laser.Angle := lect*90;
      read(fic,lect);
      Laser.temps := lect;

      if Cible = nil then begin
        Cible := TCible.create(Feuille);
        Cible.parent := Feuille;
      end
      else
        Cible.Visible := true;
      read(fic, lect);
      Cible.left := lect * 256;
      read(fic, lect);
      Cible.left := Cible.left + lect;
      read(fic, lect);
      Cible.top := lect * 256;
      read(fic, lect);
      Cible.top := Cible.top + lect;
      read(fic, lect);
      Cible.sorte := lect;


      if Feuille = frmlaseroid then
        with frmLaseroid do begin
          gauTpsLaser.MaxValue := laser.temps;
          gauTpslaser.Progress := laser.temps;
          gauTpsLaser.visible := true;
          gauTpsNiveau.MaxValue := Temps;
          gauTpsNiveau.Progress := Temps;
          gauTpsNiveau.visible := true;
          tmrTpsNiveau.enabled := true;
          mnuRecom.Enabled := true;
          if mnuBruitages.checked then begin
            Playerwav.filename := RepAct +'\sons\Debut.wav';
            Playerwav.open;
            PlayerWav.wait := true;
            Playerwav.play;
          end;
        end
      else
        frmEditeur.lblIndNiv.caption := inttostr(nivact)+'/ '+inttostr(nbniv);
    end;
  end;
  closefile(fic);
end;

function TraceLaser(Feuille : TFeuilleJeu; Xorg, Yorg : integer; Angle : integer; dessine : boolean): shortint;
var cosi,
    sinu          : extended;
    fini,
    touchemiroir  : boolean;
    mil,
    theta,
    i,
    j,
    x,
    y             : integer;
    retour        : shortint;
begin

  cosi := trunc(cos(angle*pi/180)*10000)/10000;
  sinu := -trunc(sin(angle*pi/180)*10000)/10000;

  with Feuille do begin

    fini := false;
    theta := 1;
    repeat
      x := xorg+trunc(theta*cosi);
      y := yorg+trunc(theta*sinu);
// recalcule les coordonnes dans un repre cartsien
      if (X > width) or (X < 0) or (Y > height) or (Y < 0) then begin
        fini := true;
        retour := ttAucun;
      end;

      i := 0;
// teste tous les miroirs un par un
      touchemiroir := false;
      while (not touchemiroir) and (i < nbmir) do begin
        if theta > 50 then begin
          if (X >= Miroir[i].left) and (X <= Miroir[i].left + Miroir[i].width) and (Y >= Miroir[i].top) and (Y <= Miroir[i].top + Miroir[i].height) and (Miroir[i].visible) then begin
            touchemiroir := true;
            if angle <= 180 then
              mil := 90
            else
              mil := 360;
            if ((miroir[i].angle > angle) and (miroir[i].angle < mil)) or ((miroir[i].angle>=(360-mil) mod 180) and (miroir[i].angle < (angle + 180) mod 360)) then
              retour := ttMiroirInverse
            else
              retour := TraceLaser(Feuille, trunc(Miroir[i].left + Miroir[i].width/2),trunc(Miroir[i].top + Miroir[i].height/2), (2*Miroir[i].angle-angle + 360) mod 360, dessine);

            X := trunc(Miroir[i].left + Miroir[i].width/2);
            Y := trunc(Miroir[i].top + Miroir[i].height/2);
          end;
        end;

        inc(i);
      end;

      j := 0;
// teste tous les obstacles un par un
      while (not fini) and (j < nbobs) do begin
        if (X >= Obstacle[j].left) and (X <= Obstacle[j].left + Obstacle[j].width) and (Y >= Obstacle[j].top) and (Y <= Obstacle[j].top + Obstacle[j].height) and Obstacle[j].visible then begin
          fini := true;
          retour := ttObstacle;
          frmLaseroid.ObsTouche := j;
        end;
        inc(j);
      end;

// teste le laser
      if theta > 60 then
        if (X >= Laser.left) and (X <= Laser.left + Laser.width) and (Y >= Laser.top) and (Y <= Laser.top + Laser.height) then begin
          fini := true;
          X := trunc(Laser.left + Laser.width/2);
          Y := trunc(Laser.top + Laser.height/2);
          retour := ttLaser;
        end;

// teste la cible
      if (X>=cible.left) and (x<cible.left+cible.width) and (y>cible.top) and (y<cible.top+cible.height) then begin
        fini := true;
        retour := ttCible;
        X:=trunc(cible.left+cible.width/2);
        Y:=trunc(cible.top+cible.height/2);
      end;


      fini := fini or touchemiroir;
      theta := theta +5;
// agrandit le rayon de 5 units
    until fini;
// prpare le trac
    canvas.pen.width := 2;
    Canvas.moveto(xorg,yorg);
    if dessine then begin
      canvas.pen.color := clYellow;
      Canvas.lineto(x, y);
    end
    else begin
      canvas.pen.color := clBlack;
      canvas.lineto(x, y);
      case retour of
        ttObstacle : obstacle[j-1].repaint;
        ttcible : cible.repaint;
        ttLaser : laser.repaint;
      end;
      if touchemiroir then
        miroir[i-1].repaint;
    end;
  end;
  TraceLaser := retour;
end;

function RepAct;
begin
  RepAct := extractfilepath(application.exename);
end;

procedure TFeuillejeu.CapteDepl(var msg : TMessage);
begin
  if (msg.wparam <> HTCaption) then
    inherited; 
end;

procedure TFeuilleJeu.EffaceLaser;
begin
  if frmEditeur.visible then begin
    if not frmPalette.tbtEmetteur.enabled and not frmPalette.tbtCible.enabled and (laser<>nil) and (cible<>nil) then
      TraceLaser(frmEditeur, laser.left+trunc(laser.width/2),laser.top+trunc(laser.height/2), laser.angle, false);
  end
  else
    TraceLaser(frmLaseroid, laser.left+trunc(laser.width/2),laser.top+trunc(laser.height/2), laser.angle, false);
end;

end.
