{------------------------------------------------------------------------------
                        E D I T E U R . P A S

Cette unit contient les routines de la feuille de l'diteur de niveaux, frmEditeur.
C'est elle qui gre toute l'interface d'dition.
-------------------------------------------------------------------------------}
unit Editeur;

interface


uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, ToolWin, ComCtrls, ULaser, UMiroir, UObstacle, UCible, divers,
  ExtCtrls;

type
  TfrmEditeur = class(TFeuilleJeu)
    MainMenu1: TMainMenu;
    mnuNiveau: TMenuItem;
    mnuSuivant: TMenuItem;
    mnuPrec: TMenuItem;
    N1: TMenuItem;
    mnuSauve: TMenuItem;
    mnuAjout: TMenuItem;
    mnuEditeur: TMenuItem;
    mnuPalette: TMenuItem;
    N2: TMenuItem;
    mnuQuitter: TMenuItem;
    mnuGrille: TMenuItem;
    mnuAffLaser: TMenuItem;
    tmrDessine: TTimer;
    mnuPropri: TMenuItem;
    Panel1: TPanel;
    lblIndNiv: TLabel;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure mnuQuitterClick(Sender: TObject);
    procedure mnuPaletteClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure mnuGrilleClick(Sender: TObject);
    procedure mnuAffLaserClick(Sender: TObject);
    procedure tmrDessineTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure mnuPropriClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure mnuSauveClick(Sender: TObject);
    procedure mnuAjoutClick(Sender: TObject);
    procedure FormDblClick(Sender: TObject);
    procedure mnuSuivantClick(Sender: TObject);
    procedure mnuPrecClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  frmEditeur: TfrmEditeur;

implementation

uses Principal, Palette, ConfNiv;

{$R *.DFM}

procedure TfrmEditeur.FormClose(Sender: TObject; var Action: TCloseAction);
var i : integer;
begin
// ferme la feuille et rend tous les objets invisibles.
  frmPalette.tbtCible.enabled := true;
  frmPalette.tbtEmetteur.enabled := true;
  tmrDessine.Enabled := false;
  if laser <> nil then
    Laser.visible := false;
  if cible <> nil then
    Cible.visible := false;
  for i:=0 to nbmir-1 do
    Miroir[i].visible := false;
  for i:=0 to nbobs-1 do
    Obstacle[i].visible := false;
  nbobs := 0;
  nbmir := 0;
  frmlaseroid.show;
  frmPalette.close;
end;

procedure TfrmEditeur.mnuQuitterClick(Sender: TObject);
begin
  frmEditeur.close;
end;

procedure TfrmEditeur.mnuPaletteClick(Sender: TObject);
begin
// change l'tat du menu et affiche ventuellemnt la palette d'outils.
  mnuPalette.checked := not mnuPalette.checked;
  if mnuPalette.checked then
    frmPalette.show
  else
    frmPalette.hide;
end;

procedure TfrmEditeur.FormActivate(Sender: TObject);
begin
  if not frmPalette.visible then
    frmPalette.show;
  mnuPalette.checked := true;
end;

procedure TfrmEditeur.FormResize(Sender: TObject);
begin
// cache la palette si la fentre est minimise 
  if frmEditeur.windowstate = wsminimized then begin
    frmPalette.hide;
  end
  else if (frmEditeur.windowstate = wsmaximized) and mnuPalette.checked and frmEditeur.visible then begin
    frmPalette.show;
  end;
end;

procedure TfrmEditeur.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var i : integer;
begin
// place les nouveaux objets (ventuellements aligns sur une grille.
  if mnugrille.checked then begin
    X := (X div 10) * 10;
    Y := (Y div 10) * 10;
  end;

  modifie := false;

  if button = mbleft then
    case Mode of
      mdMiroir : begin
                   if nbmir < 99 then begin
                     EffaceLaser;
                     i := 0;
// recherche un miroir non utilis
                     while (i<nbmir) and (Miroir[i].visible) do
                       inc(i);
                     if i>=nbmir then begin
// si le miroir n'existe pas, on le cre
                       if Miroir[i] = nil then begin
                         Miroir[nbmir] := TMiroir.create(frmEditeur);
                         Miroir[i].parent := frmEditeur;
                       end
                       else
                         Miroir[i].visible := true;
                       i := nbmir;
                       inc(nbmir);
                     end
                     else
                       Miroir[i].visible := true;
                     Miroir[i].left := X - round(miroir[i].width / 2);
                     Miroir[i].top := Y - round(miroir[i].height / 2);
                     Miroir[i].angle := 0;
                     Miroir[i].Edition := true;
                   end;
                 end;
      mdCible : begin
                  frmPalette.tbtCible.enabled := false;
                  frmPalette.tbtCible.down := false;
                  frmPalette.tbtFleche.down := true;
                  mode := mdNormal;
                  if cible = nil then begin
                    Cible := TCible.create(frmEditeur);
                    cible.parent := frmEditeur;
                  end
                  else
                    cible.visible := true;
                  cible.sorte := 0;
                  cible.left := X - round(cible.width / 2);
                  cible.top := Y - round(cible.height / 2);
                  cible.Edition := true;
                  cursor := crDefault;
                end;
      mdEmetteur : begin
                     frmPalette.tbtEmetteur.enabled := false;
                     frmPalette.tbtEmetteur.down := false;
                     frmPalette.tbtFleche.down := true;
                     mode := mdNormal;
                     if laser = nil then begin
                       laser := Tlaser.create(frmEditeur);
                       laser.parent := frmEditeur;
                     end
                     else
                       laser.visible := true;
                     laser.angle := 0;
                     laser.left := X - round(laser.width / 2);
                     laser.top := Y -round(laser.height / 2);
                     laser.Edition := true;
                     cursor := crDefault;
                   end;
      mdObstacle1,
      mdObstacle2 : begin
                      if nbobs < 99 then begin
                        EffaceLaser;
                        i := 0;
                        while (i<nbobs) and (Obstacle[i].visible) do
                          inc(i);
                        if i>=nbobs then begin
                          if Obstacle[nbobs] = nil then begin
                            Obstacle[nbobs] := TObstacle.create(frmEditeur);
                            Obstacle[i].parent := frmEditeur;
                          end
                          else
                            Obstacle[i].visible := true;
                          i := nbobs;
                          inc(nbobs);
                        end
                        else
                          Obstacle[i].visible := true;
                        Obstacle[i].sorte := mode-mdObstacle1;
                        Obstacle[i].left := X - round(Obstacle[i].width / 2);
                        Obstacle[i].top := Y - round(Obstacle[i].height / 2);
                        Obstacle[i].Edition := true;
                      end;
                    end;
  end;
// l'espace de jeu a t modifi
  modifie := true;
end;

procedure TfrmEditeur.mnuGrilleClick(Sender: TObject);
begin
// change l'tat du menu
  mnuGrille.checked := not mnugrille.checked;
  Grille := mnuGrille.checked;
end;

procedure TfrmEditeur.mnuAffLaserClick(Sender: TObject);
begin
// change l'tat du menu
  mnuAffLaser.checked := not mnuAfflaser.checked;
  if not mnuAffLaser.checked then
    EffaceLaser
  else
    modifie := true;
end;

procedure TfrmEditeur.tmrDessineTimer(Sender: TObject);
begin
// redessine ventuellment le laser et met  jour la palette si l'metteur et/ou
// la cible sont absents.
  if Modifie and mnuAfflaser.checked and not frmPalette.tbtEmetteur.enabled and not frmPalette.tbtCible.enabled then begin
    typeTouche := TraceLaser(frmEditeur, laser.left+trunc(laser.width/2),laser.top+trunc(laser.height/2), laser.angle, true);
    modifie := false;
  end;
  if not frmPalette.tbtEmetteur.enabled and not frmPalette.tbtCible.enabled and (laser<>nil) and (cible<>nil) then
    mnuAfflaser.enabled := true
  else begin
    mnuAfflaser.enabled := false;
    mnuAfflaser.checked := false;
  end;
end;

procedure TfrmEditeur.FormCreate(Sender: TObject);
begin
  nbobs := 0;
  nbmir := 0;
  Grille := mnuGrille.checked;
end;

procedure TfrmEditeur.FormDestroy(Sender: TObject);
var i : integer;
begin
// libration des objets allous
  tmrDessine.Enabled := false;
  for i:=0 to 99 do
    Obstacle[i].free;
  for i:=0 to 9 do
    Miroir[i].free;

  Laser.free;
  cible.free;
end;

procedure TfrmEditeur.mnuPropriClick(Sender: TObject);
begin
  frmConfNiv.showmodal;
end;

procedure TfrmEditeur.FormShow(Sender: TObject);
var i : integer;
begin
// initialise l'diteur
  if frmLaseroid.nivact > 0 then
    ChargeNiveau(frmEditeur, frmLaseroid.nivact)
  else
    ChargeNiveau(frmEditeur, 1);
  for i := 0 to nbmir - 1 do
    Miroir[i].Edition := true;
  for i := 0 to nbobs - 1 do
    Obstacle[i].Edition := true;
  Laser.Edition := true;
  frmPalette.tbtEmetteur.Enabled := false;
  Cible.Edition := true;
  frmPalette.tbtCible.Enabled := false;
  mnuAffLaser.Enabled := true;
  If NivAct = NbNiv then
    mnuSuivant.Enabled := false;
  If NivAct = 1 then
    mnuPrec.Enabled := false;
  tmrDessine.enabled := true;
end;

procedure TfrmEditeur.mnuSauveClick(Sender: TObject);
var fic       : file of byte;
    adr       : word;
    tmpNbMir,
    tmpNbObs,
    ecr       : byte;
    i         : integer;
begin
// sauvegarde le niveau actuel aprs avour vrifi que tous les renseignements ont t
// fournis
  if Titre = '' then begin
    application.MessageBox('Vous n''avez pas spcifi le titre du niveau.'+#13+'Impossible d''enregistrer.','Titre manquant',MB_OK+MB_ICONERROR);
    exit;
  end;
  if Passe = '' then begin
    application.messagebox('Vous n''avez pas spcifi le mot de passe du niveau.'+#13+'Impossible d''enregistrer.','Mot de passe manquant',MB_OK+MB_ICONERROR);
    exit;
  end;
  if Temps = 0 then begin
    application.messagebox('Vous n''avez pas spcifi le temps de jeu du niveau.'+#13+'Impossible d''enregistrer.','Temps de jeu manquant',MB_OK+MB_ICONERROR);
    exit;
  end;
  if laser = nil then begin
    application.messagebox('Vous n''avez pas plac le Laser.'+#13+'Impossible d''enregistrer.','Laser manquant',MB_OK+MB_ICONERROR);
    exit;
  end;
  if Cible = nil then begin
    application.messagebox('Vous n''avez pas plac la cible.'+#13+'Impossible d''enregistrer.','Cible manquante',MB_OK+MB_ICONERROR);
    exit;
  end;

  AssignFile(fic, RepAct+'\niveaux.dat');
  reset(fic);
  read(fic, ecr);                                     // saute le premier octet
  seek(fic, nivact*2-1);
  read(fic, ecr);
  adr := ecr * 256;
  read(fic, ecr);
  adr := adr + ecr;
  seek(fic, adr);
  for i := 1 to length(Passe) do begin
    ecr := ord(passe[i]);
    Write(fic, ecr);
  end;
  for i := length(passe) to 7 do begin
    ecr := 0;
    Write(fic, ecr);
  end;

  for i := 1 to length(Titre) do begin
    ecr := ord(titre[i]);
    Write(fic, ecr);
  end;
  for i := length(Titre) to 19 do begin
    ecr := 0;
    Write(fic, ecr);
  end;

  write(fic, temps);

  tmpNbMir := 0;
  tmpNbObs := 0;

  for i:= 0 to nbmir-1 do
    if Miroir[i].visible then
      inc(tmpnbMir);

  for i:= 0 to nbobs-1 do
    if Obstacle[i].visible then
      inc(tmpnbobs);

  write(fic, tmpNbMir);
  for i:= 0 to nbmir -1 do
    if Miroir[i].visible then begin
      ecr := Miroir[i].left div 256;
      write(fic, ecr);
      ecr := Miroir[i].left mod 256;
      write(fic, ecr);
      ecr := Miroir[i].top div 256;
      write(fic, ecr);
      ecr := Miroir[i].top mod 256;
      write(fic, ecr);
      ecr := Miroir[i].angle div 5;
      write(fic, ecr);
    end;

  write(fic, tmpNbObs);
  for i:= 0 to nbObs -1 do
    if Obstacle[i].visible then begin
      ecr := Obstacle[i].left div 256;
      write(fic, ecr);
      ecr := Obstacle[i].left mod 256;
      write(fic, ecr);
      ecr := Obstacle[i].top div 256;
      write(fic, ecr);
      ecr := Obstacle[i].top mod 256;
      write(fic, ecr);
      ecr := Obstacle[i].sorte;
      write(fic, ecr);
    end;

  ecr := Laser.left div 256;
  write(fic, ecr);
  ecr := Laser.left mod 256;
  write(fic, ecr);
  ecr := Laser.top div 256;
  write(fic, ecr);
  ecr := Laser.top mod 256;
  write(fic, ecr);
  ecr := Laser.angle div 90;
  write(fic, ecr);
  write(fic, Laser.temps);

  ecr := Cible.left div 256;
  write(fic, ecr);
  ecr := Cible.left mod 256;
  write(fic, ecr);
  ecr := Cible.top div 256;
  write(fic, ecr);
  ecr := Cible.top mod 256;
  write(fic, ecr);
  ecr := Cible.sorte;
  write(fic, ecr);

  seek(fic, 0);
  write(fic, nbniv);
  closefile(fic);

end;

procedure TfrmEditeur.mnuAjoutClick(Sender: TObject);
var fic       : file of byte;
    locnbniv,
    ecr       : byte;
    i         : integer;
begin
// ajoute un niveau  dans le fichier de niveaux
  AssignFile(fic, RepAct+'\niveaux.dat');
  reset(fic);
  read(fic, locnbniv);
  seek(fic, (locnbniv+1)*2-1);
  ecr := FileSize(fic) div 256;
  write(fic, ecr);
  ecr := FileSize(fic) mod 256;
  write(fic, ecr);
  inc(nbniv);
  nivact := nbniv;

  for i:= 0 to nbmir-1 do
    Miroir[i].visible := false;
  for i:= 0 to nbobs-1 do
    Obstacle[i].visible := false;
  if laser <> nil then
    Laser.visible := false;
  if cible <> nil then
    Cible.visible := false;
  frmPalette.tbtEmetteur.Enabled := true;
  frmPalette.tbtCible.Enabled := true;
  Passe := '';
  Titre := '';
  Temps := 0;

  closefile(fic);
end;

procedure TfrmEditeur.FormDblClick(Sender: TObject);
begin
  mnuPropriClick(Sender);
end;

procedure TfrmEditeur.mnuSuivantClick(Sender: TObject);
begin
// passe au niveau suivant
  inc(nivact);
  if nivact = nbniv then mnuSuivant.Enabled := false;
  mnuPrec.Enabled := true;
  ChargeNiveau(frmEditeur, nivact);
end;

procedure TfrmEditeur.mnuPrecClick(Sender: TObject);
begin
// passe au niveau prcdent
  dec(nivact);
  if nivact = 1 then mnuPrec.Enabled := false;
  mnuSuivant.Enabled := true;
  ChargeNiveau(frmEditeur, nivact);
end;

procedure TfrmEditeur.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  canclose := application.messagebox('tes-vous sr(e) de vouloir quitter l''diteur ?','Quitter l''diteur',MB_YESNO+MB_ICONQUESTION) = mrYES;
end;

end.
