{------------------------------------------------------------------------------
                      P R I N C I P A L . P A S

Cette unit contient les routines de la feuille principale, frmLaseroid.
C'est elle qui gre toute l'interface de jeu.
-------------------------------------------------------------------------------}
unit Principal;

interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  MPlayer, ExtCtrls, StdCtrls, Menus, Divers, Gauges;


type
// classe pour la feuille
  TfrmLaseroid = class(TFeuilleJeu)
    MainMenu1: TMainMenu;
    mnuPartie: TMenuItem;
    mnuNouvelle: TMenuItem;
    N1: TMenuItem;
    mnuQuitter: TMenuItem;
    mnuOptions: TMenuItem;
    mnuMusique: TMenuItem;
    mnuBruitages: TMenuItem;
    PlayerMidi: TMediaPlayer;               // pour jouer la musique
    PlayerWav: TMediaPlayer;                // pour les bruitages
    PlayerMiroir: TMediaPlayer;             // pour les bruits de miroir
    tmrDessine: TTimer;
    N2: TMenuItem;
    mnuEditeur: TMenuItem;
    mnuSons: TMenuItem;
    tmrTpsNiveau: TTimer;
    Panel1: TPanel;
    gauTpsNiveau: TGauge;
    gauTpsLaser: TGauge;
    mnuRecom: TMenuItem;
    mnuAPropos: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure mnuMusiqueClick(Sender: TObject);
    procedure mnuBruitagesClick(Sender: TObject);
    procedure mnuQuitterClick(Sender: TObject);
    procedure tmrDessineTimer(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure mnuEditeurClick(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure PlayerMidiNotify(Sender: TObject);
    procedure mnuNouvelleClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Gagne;
    procedure Perdu;
    procedure tmrTpsNiveauTimer(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure mnuRecomClick(Sender: TObject);
    procedure mnuAProposClick(Sender: TObject);
  private
    { Dclarations prives }

  end;

var
  frmLaseroid : TfrmLaseroid;

implementation

uses Editeur, Nouvpart, Present;

{$R *.DFM}
{$R curseurs.res}             // pour les curseurs personaliss



procedure TfrmLaseroid.FormCreate(Sender: TObject);
begin
// mises en place des handle de curseurs.
  screen.cursors[crlaser] := loadcursor(hinstance, 'curlaser');
  screen.cursors[crtrnmir] := loadcursor(hinstance, 'curtrnMir');
  screen.cursors[crcible] := loadcursor(hinstance, 'curcible');
  screen.cursors[crobs1] := loadcursor(hinstance, 'curobs1');
  screen.cursors[crobs2] := loadcursor(hinstance, 'curobs2');
  screen.cursors[crgomme] := loadcursor(hinstance, 'curgomme');
  screen.cursors[crmiroir] := loadcursor(hinstance, 'curmiroir');
// dmarrage ventuel du son
  if mnuMusique.checked then begin
    PlayerMidi.filename := Repact+'\sons\t.mid';
    PlayerMidi.open;
    PlayerMidi.play;
  end ;
  Modifie := false;                   // pas de modification de l'espace de jeu
  Nivact := 0;                        // pas de niveau charg
  ObsTouche := -1;                    // pas d'obstacle touch
  tmrTpsNiveau.Enabled := false;       // pas de dfilement du temps
end;

procedure TfrmLaseroid.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Application.terminate;           // fin de l'application
end;

procedure TfrmLaseroid.mnuMusiqueClick(Sender: TObject);
begin
// on change l'tat du menu musique et on met  jour.
  mnuMusique.checked := not mnumusique.checked;
  if mnuMusique.checked then begin
    PlayerMidi.filename := Repact+'\sons\t.mid';
    PlayerMidi.open;
    PlayerMidi.play;
  end
  else
    PlayerMidi.Close;
end;

procedure TfrmLaseroid.mnuBruitagesClick(Sender: TObject);
begin
// On change l'tat et on met  jour
  mnuBruitages.checked := not mnuBruitages.checked;
  if not mnuBruitages.checked then
    PlayerWav.Close;
end;

procedure TfrmLaseroid.mnuQuitterClick(Sender: TObject);
begin
// On ferme la feuille ce qui va faire quitter.
  frmLaseroid.close;
end;


procedure TfrmLaseroid.tmrDessineTimer(Sender: TObject);
var i : integer;
begin
// c'est ici qu'on vrifie tous les 5 centimes de secondes si l'espace de jeu
// doit tre redessin ou pas
  if Modifie and Laser.actif then begin
    typeTouche := TraceLaser(frmLaseroid, laser.left+trunc(laser.width/2),laser.top+trunc(laser.height/2), laser.angle, true);
    modifie := false;
// vrifie si on a touch un objet et agit en consquence
    case typetouche of
      ttCible : Gagne;
      ttLaser : begin
                  Laser.temps := 0;
                  EffaceLaser;
                  If mnuBruitages.checked then begin
                    Playerwav.Filename := repAct + '\sons\LasCasse.wav';
                    Playerwav.open;
                    Playerwav.wait := true;
                    PlayerWav.play;
                  end;
                  Perdu;
                end;
      ttObstacle : begin
                     Obstacle[ObsTouche].Destruction(true);
                     for i:= 0 to nbobs-1 do
                       if i <> ObsTouche then
                         Obstacle[i].destruction(false);
                   end;
      else       if ObsTouche > -1 then Obstacle[ObsTouche].Destruction(false);
    end;
  end;
end;

procedure TfrmLaseroid.FormPaint(Sender: TObject);
begin
// retrace ventuellment le laser, les autres objets se dbrouillants tout seuls
  if laser <> nil then
    if laser.actif then
      typetouche := TraceLaser(frmLaseroid, laser.left+trunc(laser.width/2),laser.top+trunc(laser.height/2), laser.angle, true);
end;

procedure TfrmLaseroid.mnuEditeurClick(Sender: TObject);
begin
// Lance l'diteur
  tmrTpsNiveau.enabled := false;
  frmEditeur.show;
  frmLaseroid.hide;
end;

procedure TfrmLaseroid.FormHide(Sender: TObject);
begin
// empche les vrifications alors qu'on ne voit rien
  tmrDessine.enabled := false;
end;

procedure TfrmLaseroid.FormShow(Sender: TObject);
begin
// Relance les vrifications.
  tmrDessine.enabled := true;
// si frmPresent est  nil alors c'est qu'on dmarre l'application donc on affiche
// la fentre A propos. On ne le fait pas lors de la cration de la feuille frmLaseroid
// car cela pose des problmes (feuille permanente) 
  if frmPresent = nil then begin
    Application.CreateForm(TfrmPresent, frmPresent);
    frmPresent.showmodal;
  end;
end;

procedure TfrmLaseroid.PlayerMidiNotify(Sender: TObject);
begin
// On vrifie ici si on peut renvoyer une nouvelle boucle pour la musique.
  if mnuMusique.checked then
    PlayerMidi.play
  else
    PlayerMidi.Close;
end;

procedure TfrmLaseroid.mnuNouvelleClick(Sender: TObject);
var resultat : integer;
    avant    : boolean;
begin
// dclenche la mise en route d'une nouvelle partie.
  avant := tmrTpsNiveau.enabled;
  tmrTpsNiveau.enabled := false;
  resultat := frmNouvPart.showmodal;
  tmrTpsNiveau.enabled := avant;
  if resultat > 0 then begin
    ChargeNiveau(frmLaseroid, resultat);
    tmrTpsNiveau.Enabled := true;
  end;
end;

procedure TfrmLaseroid.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
var avant : boolean;
begin
// vrifie que l'utilisateur veut bien quitter et dsactive momentanment le laser.
  if laser <> nil then begin
    effaceLaser;
    avant := Laser.actif;
    Laser.actif := false;
  end;
  CanClose := application.messagebox('tes-vous sr(e) de vouloir quitter ?','Quitter',MB_ICONQUESTION+MB_YESNO+MB_DEFBUTTON2) = mrYes;
  if laser <> nil then
    Laser.actif := avant;
end;

procedure TFrmLaseroid.Gagne;
var i : integer;
begin
// Flicite le joueur quand il a gagn et lui demande s'il veut continuer.
  tmrTpsNiveau.Enabled := false;
  TraceLaser(frmLaseroid, laser.left+trunc(laser.width/2),laser.top+trunc(laser.height/2), laser.angle, true);
  if mnuBruitages.checked then begin
    Playerwav.filename := Repact+'\sons\cheer.wav';
    Playerwav.open;
    playerwav.play;
  end;
  if nivact < nbniv then begin
    if application.messagebox('C''est gagn'+#13+'Voulez-vous passer au niveau suivant ?','Niveau suivant', MB_YESNO+MB_ICONQUESTION) = mrYes then begin
      inc(nivact);
      Laser.actif := false;
      Chargeniveau(frmLaseroid, nivact);
    end;
  end
  else
  begin
// si tous les niveaux sont finis alors on va s'arrter
    Laser.actif := false;
    showmessage('BRAVO !!!!'+#13+'Vous avez russi tous les niveaux.');
    EffaceLaser;
    tmrTpsNiveau.Enabled := false;
    Laser.visible := false;
    Cible.visible := false;
    for i:= 0 to nbmir-1 do
      Miroir[i].visible := false;
    for i := 0 to nbobs -1 do
      Obstacle[i].visible := false;
    gauTpsNiveau.visible := false;
    gauTpsLaser.visible := false;
  end;
  EffaceLaser;
end;

procedure TFrmLaseroid.Perdu;
var i : integer;
begin
// Informe le joueur qu'il a perdu et lui propose une nouvelle partie.
  tmrTpsNiveau.enabled := false;
  if mnuBruitages.checked then begin
    playerwav.filename:=RepAct +'\sons\perdu.wav';
    playerwav.open;
    playerwav.Play;
  end;
  if Application.Messagebox('C''est perdu'+#13+'Voulez vous recommencer ce niveau ?','Perdu', MB_YESNO+MB_ICONQUESTION) = mrYES then begin
    EffaceLaser;
    tmrTpsNiveau.Enabled := false;
    Laser.visible := false;
    Cible.visible := false;
    for i:= 0 to nbmir-1 do
      Miroir[i].visible := false;
    for i := 0 to nbobs -1 do
      Obstacle[i].visible := false;
    Laser.actif := false;
    ChargeNiveau(frmLaseroid, nivact);
    tmrTpsNiveau.Enabled := true;
  end
  else
    EffaceLaser;
end;

procedure TfrmLaseroid.tmrTpsNiveauTimer(Sender: TObject);
begin
// met  jour l'affichage du temps dans les gauges.
  if gauTpsNiveau.MaxValue <> 255 then
    gauTpsNiveau.AddProgress (-1);

  if gauTpsNiveau.Progress = 0 then
    Perdu;

  gauTpsLaser.progress := Laser.Temps;
  if Laser.temps <= 0 then
    Perdu;
end;

procedure TfrmLaseroid.FormActivate(Sender: TObject);
begin
  if nivact>0 then
    tmrTpsNiveau.Enabled := true;
end;

procedure TfrmLaseroid.mnuRecomClick(Sender: TObject);
var i : integer;
begin
// Propose  l'utilisateur de recommencer le niveau qu'il a commenc  jouer.
  tmrTpsNiveau.Enabled := false;
  if application.messagebox('tes-vous sr(e) de vouloir recommencer ce niveau ?','Nouvelle partie',MB_ICONQUESTION+MB_YESNO+MB_DEFBUTTON2) = mrYes then begin
    Laser.visible := false;
    Cible.visible := false;
    for i:= 0 to nbmir-1 do
      Miroir[i].visible := false;
    for i := 0 to nbobs -1 do
      Obstacle[i].visible := false;
    Laser.actif := false;
    ChargeNiveau(frmLaseroid, nivact);
    tmrTpsNiveau.Enabled := true;
  end;
end;

procedure TfrmLaseroid.mnuAProposClick(Sender: TObject);
begin
// affiche la feuille d'informations sur le jeu
  if laser <> nil then
    Laser.actif := false;
  frmPresent.showmodal;
end;

end.
