{------------------------------------------------------------------------------
                         U L A S E R . P A S

Cette unit contient les routines de gestion du laser. Ainsi le laser peut tre
considr comme un objet instanci par les feuilles de jeu et d'tion
-------------------------------------------------------------------------------}
unit ULaser;

interface
uses ExtCtrls, classes;

type
  TLaser = class(TImage)
    procedure UserMouseMove(Sender : TObject; Shift : TShiftState; X, Y : integer);
    procedure UserClick(Sender : TObject);
    procedure UserDblClick(Sender : TObject);
    procedure ChangeAngle(Angle: Integer);
    procedure ChangeActif(NouvActif : boolean);
    procedure CompteTps(Sender : TObject);
    constructor Create(AOwner : TComponent); override;
    destructor Destroy; override;
  protected
    Decompte  : TTimer;                        // pour compter le temps d'activit
    FAngle    : integer;                       // angle du laser
    Ftemps    : byte;                          // temps restant
    FEdition,
    Factif    : boolean;                       // vrai alors il est actif
  published
    property Angle : integer read FAngle write ChangeAngle;
    property Actif : boolean read FActif write ChangeActif;
    property Temps : byte read FTemps write FTemps;
    property Edition : boolean read FEdition write FEdition;
  end;


implementation
uses ChoixLaser, divers, SysUtils, Palette, Principal;


procedure TLaser.UserMouseMove(Sender : TObject; Shift : TShiftState; X, Y : integer);
begin
// dplace le laser
  if (parent as TFeuilleJeu).Grille then begin
    X := (X div 10) * 10;
    Y := (Y div 10) * 10;
  end;
  if Edition and (shift = [ssleft]) then begin
    (parent as TFeuilleJeu).EffaceLaser;
    top := top + Y - round(height/2);
    left := left + X - round(width/2);
    (parent as TFeuilleJeu).modifie := true;
  end;
  inherited;
end;

procedure Tlaser.UserDblClick(Sender : TObject);
var resultat : integer;
begin
// propose de modifier les paramtres du laser
  if Edition then begin
    case Angle div 90 of
      0 : frmChoixLaser.btnLaser1.down := true;
      1 : frmChoixLaser.btnLaser2.down := true;
      2 : frmChoixLaser.btnLaser3.down := true;
      3 : frmChoixLaser.btnLaser4.down := true;
    end;
    frmChoixLaser.edtTpsLaser.text := inttostr(Temps);
    resultat := frmChoixLaser.showmodal - 1;
    if resultat > -1 then begin
      (parent as TfeuilleJeu).EffaceLaser;
      Temps := strtoint(frmChoixLaser.edtTpsLaser.text);
      Angle := resultat * 90;
      Picture.loadfromfile(RepAct+'\images\Laser'+inttostr(1+resultat)+'.bmp');
      (parent as TFeuilleJeu).modifie := true;
    end;
  end;
  inherited;
end;

procedure TLaser.userclick(Sender : TObject);
begin
  inherited;
// disparait s'il le faut
  if Edition then begin
    if (parent as TfeuilleJeu).mode = mdGomme then begin
      (parent as TfeuilleJeu).EffaceLaser;
      frmPalette.tbtEmetteur.enabled := true;
      visible := false;
    end;
  end
  else begin
    Actif := not Actif;
  end;
end;

procedure TLaser.ChangeAngle(Angle : integer);
begin
// met  jour l'image en fonction de l'angle
  FAngle := Angle;
  Picture.loadfromfile(RepAct+'\images\Laser'+inttostr(1+Fangle div 90)+'.bmp');

end;

procedure TLaser.ChangeActif(NouvActif : boolean);
begin
// met  jour l'coulement du temps
  if Temps > 0 then
    Factif := Nouvactif
  else
    FActif := false;

  Decompte.Enabled := FActif;

  if Factif then begin
    with frmLaseroid do begin
      if mnuBruitages.checked then begin
        playerwav.filename := RepAct + '\sons\laser.wav';
        playerwav.open;
        playerwav.play;
      end;
      modifie := true;
    end;
  end
  else
    with frmLaseroid do
      TraceLaser(frmLaseroid, laser.left+trunc(laser.width/2),laser.top+trunc(laser.height/2), laser.angle, false);
end;

procedure TLaser.CompteTps(Sender:Tobject);
begin
  if (Temps < 255) and not Edition then
    Temps := Temps - 1;
end;

constructor Tlaser.Create(AOwner : TComponent);
begin
  inherited;

// cration du laser
  transparent := false;
  autosize := true;
  FAngle := 0;
  FTemps := 1;
  Factif := false;
  Decompte := TTimer.Create(AOwner);
  Decompte.interval := 1000;
  Decompte.Enabled := false;
  Decompte.OnTimer := CompteTps; 
  FEdition := false;
  OnMouseMove := UsermouseMove;
  OnClick := UserClick;
  OnDblClick := UserDblClick;
end;


destructor TLaser.Destroy;
begin
// libration des onjets instancis
  Decompte.free;
  inherited
end;

end.
