{------------------------------------------------------------------------------
                         U O B S T A C L E . P A S

Cette unit contient les routines de gestion du miroir. Ainsi l'obstacle peut
tre considr comme un objet instanci par les feuilles de jeu et d'tion
-------------------------------------------------------------------------------}
unit UObstacle;


interface
uses extctrls, classes;

type
  TObstacle = class(TImage)
    procedure UserMouseMove(Sender : TObject; Shift : TShiftState; X, Y : integer);
    procedure UserClick(Sender : TObject);
    procedure ChangeSorte(Sorte : byte);
    procedure Destruction(Oui : boolean);
    procedure Decompte(Sender : TObject);
    constructor Create(AOwner : TComponent); override;
    destructor Destroy; override;
  private
    FSorte : byte;                                    // type de l'obstacle
    FEdition : boolean;
  public
    Etat     : byte;                                   // tat de la destruction
    Compteur : TTimer;                                 // pour la destruction
  published
    property Sorte : byte read FSorte write ChangeSorte;
    property Edition : boolean read FEdition write FEdition;
  end;


implementation
uses divers, sysutils;

procedure TObstacle.UserMouseMove(Sender : TObject; Shift : TShiftState; X, Y : integer);
begin
  inherited;
  if (parent as TFeuilleJeu).Grille then begin
    X := (X div 10) * 10;
    Y := (Y div 10) * 10;
  end;
// dplace l'objet
  if Edition and (shift = [ssLeft]) then begin
    (parent as TfeuilleJeu).EffaceLaser;
    top := top + Y - round(height/2);
    left := left + X - round(width/2);
    (parent as TfeuilleJeu).modifie := true;
  end;
end;

procedure TObstacle.UserClick(Sender : TObject);
begin
  inherited;
// disparait si ncessaire
  if Edition then
    if (parent as TfeuilleJeu).mode = mdGomme then begin
      visible := false;
    end;
end;

procedure TObstacle.ChangeSorte(Sorte : byte);
begin
// charge la bonne image
  FSorte := Sorte;
  Picture.loadfromfile(RepAct+'\images\Obs'+inttostr(1+FSorte)+'.bmp');

end;

procedure TObstacle.Destruction(Oui : boolean);
begin
// provoque ou pas la destruction
  if (Sorte = 0) and (Etat > 0) then
    compteur.Enabled := Oui
  else
    compteur.Enabled := False;
end;

procedure TObstacle.Decompte(Sender : TObject);
begin
// effectue l'animation de destruction
  if Etat > 12 then
    picture.loadfromfile(RepAct + '\images\expl0'+inttostr(22-Etat)+'.bmp')
  else
    picture.loadfromfile(RepAct + '\images\expl'+inttostr(22-Etat)+'.bmp');
  dec(Etat);
  if Etat = 0 then begin
    (Parent as TfeuilleJeu).EffaceLaser;
    Visible := false;
    Compteur.enabled := false;
    (Parent as TFeuilleJeu).modifie := true;
  end;
end;

constructor TObstacle.Create(AOwner : TComponent);
begin
  inherited;
// initialise l'obstacle
  compteur := TTimer.Create(Owner);
  compteur.Interval := 100;
  compteur.Enabled := false;
  compteur.OnTimer := Decompte;
  transparent := false;
  autosize := true;
  OnMouseMove := UserMouseMove;
  Onclick := userclick;
  FEdition := false;
  Sorte := 0;
  Etat := 20;
end;

destructor TObstacle.Destroy;
begin
// libre les objets instancis
  Compteur.free;
  inherited;
end;

end.
